
/*

Christof Ermer
10.03.2020
*/

#include "main.h"

#ifndef MORSE_TX_H
	#define MORSE_TX_H

//#define TIMER0_SPEED	1000U
#define TIMER2_SPEED	72000UL // Fuer IR Sender
#define TIMER0_SPEED_1MS	(TIMER0_SPEED/1000)
#define DEFAULT_MORSESPEED_POINT    70 //ms // (uint16_t)(TIMER0_SPEED_1MS *100U)
#define TXJOB_MAX	25

//1500 Hz
#define BEEP_PUNKT_FRQ 2000U
#define BEEP_STRICH_FRQ 1800U

#define BEEP_PUNKT_F  (uint16_t)(TIMER2_SPEED / BEEP_PUNKT_FRQ / 2U) // 240 /1500 Hz Herz
#define BEEP_STRICH_F (uint16_t)(TIMER2_SPEED / BEEP_STRICH_FRQ  / 2U)  //160
/*
.=1*
-=3*
" "=7*
Affe
.- ..-. ..-. .
.1-3.1.1-1.3.1.1-1.7
.=1
-=3
" " = 
'1'= 1* Punkt
'3'= 3* Punkt
'7'= 7* Punkt
______________________
-------
-1-1-1-1-1-1-7\0  =15
Ein Dah ist dreimal so lang wie ein Dit.
Die Pause zwischen zwei gesendeten Symbolen ist ein Dit lang.
Zwischen Buchstaben in einem Wort wird eine Pause von der Lnge eines Dah (oder drei Dits) eingeschoben.
Die Lnge der Pause zwischen Wrtern entspricht sieben Dits.
*/

//36KHz=  OC2A = PB3
// PSP = PunktStrichPause 
// ClearAllFlags();

typedef struct
{ //P-S-P Punkt-Strich-Pause
uint8_t TXBYte_OK : 1;
uint8_t Str_TXActive : 1;
uint8_t PSP_JobStart : 1; //P-S-P
uint8_t PSP_JobActive : 1; //String
uint8_t Morse_Busy : 1; //(Start + JobActive)
uint8_t PSP_TXActive : 1; //Sendet gerade H/L
uint8_t Morse_SoundOn : 1;
uint8_t TX_Punkt : 1;
uint8_t TX_Strich : 1;
uint8_t TX_Pause : 1;
uint8_t StrReady : 1;

uint8_t u8MorseVal ;
uint8_t u8TxChar;
uint8_t u8CodeOffset;
char	caTxJobStr[ TXJOB_MAX+1 ]; // Hier Info '.' '-' 123Pause
uint16_t u16MorseSpeed;
uint16_t u16MorseTonFrq;
uint16_t u16SignalTxZeit;  // Timer#
}MORSE_TYPE;
//gstMorseTx.

#define MORSETX_PORTX	PORTD
#define MORSETX_DDRX	DDRD
#define MORSETX_BIT		_BV(3)
#define INIT_MORSETX_DATA() (MORSETX_DDRX |= MORSETX_BIT)
#define SET_MORSETX() 	(MORSETX_PORTX |= MORSETX_BIT)
#define CLR_MORSETX() 	(MORSETX_PORTX &= ~MORSETX_BIT)
/*
#define SOUND_TX_PORTX	PORTD
#define SOUND_TX_DDRX	DDRD
#define SOUND_TX_BIT	_BV(4)
#define INIT_SOUND_TX() (SOUND_TX_DDRX |= SOUND_TX_BIT)
#define CLR_SOUND_TX() 	(SOUND_TX_PORTX &= ~SOUND_TX_BIT)
#define TOGGLE_SOUND_TX() (SOUND_TX_PORTX ^= SOUND_TX_BIT)
*/

#define BUSY_TX_PORTX	PORTD
#define BUSY_TX_DDRX	DDRD
#define BUSY_TX_BIT		_BV(4)
#define INIT_BUSY_TX()	(BUSY_TX_DDRX |= BUSY_TX_BIT)
#define CLR_BUSY_TX() 	(BUSY_TX_PORTX &= ~BUSY_TX_BIT)
#define SET_BUSY_TX() 	(BUSY_TX_PORTX |= BUSY_TX_BIT)
#define CLR_BUSY_TX() 	(BUSY_TX_PORTX &= ~BUSY_TX_BIT)
#define TOGGLE_BUSY_TX() (BUSY_TX_PORTX ^= BUSY_TX_BIT)
#define CLR_TXDATA()

// extern // ******************************
extern MORSE_TYPE gstMorseTx;
extern void Init_MorseTx(void);
extern void TxMorseByte( uint8_t u8Byte );
extern void TxMorseStr( char * pxStr);
extern void ManageTxInterrupt(void);
extern void MorseBuf_Polling(void);

#endif	//MORSE_TX_H

/*
uint16t u16MT= 	(gstMorseTx.TXChar_Act) \
		| (gstMorseTx.TX_Start << 1) \
		| (gstMorseTx.TX_Stop << 2) \
		| (gstMorseTx.TX_Ready. << 3) \
		| (gstMorseTx.TXBYte_OK << 4) \
		| (gstMorseTx.Tx_Punkt << 5) \
		| (gstMorseTx.TX_Strich << 6) \
		| (gstMorseTx.TX_Pause << 7) \
		| (gstMorseTx.TX_WortPause << 8);

*/
